import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import org.gicentre.utils.stat.*; 
import java.util.*; 
import controlP5.*; 
import processing.serial.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class ponyplot extends PApplet {





ControlP5 cp5;

public class Button {
  String code;
  String text;
  int col;
}

ArrayList<XYChart> lineCharts = new ArrayList<XYChart>(10);
ArrayList<ArrayList<PVector>> graphData = new ArrayList<ArrayList<PVector>>();
int activeChart = 0;
ArrayList<Button> buttons = new ArrayList<Button>();

int graphStartMillis =0;
int maxXDataLength = 50;
String pageTitle = "";
String pageSubtitle = "";

float setMaxY=1;
float setMinY=0;
float setMaxX=1;
float setMinX=0;

public void addChartWithSettingsAndData() {
  lineCharts.add(new XYChart(this));
  graphData.add(new ArrayList<PVector>());
  int index = lineCharts.size()-1;
  if (index==0) {
    lineCharts.get(index).showXAxis(true); 
    lineCharts.get(index).showYAxis(true); 
  } else {
    lineCharts.get(index).showXAxis(false); 
    lineCharts.get(index).showYAxis(false);
  }
  lineCharts.get(index).setMinY(setMinY);
  lineCharts.get(index).setMaxY(setMaxY);
  lineCharts.get(index).setMinX(setMinX);
  lineCharts.get(index).setMaxX(setMaxX);
     
//  lineChart.setYFormat("$###,###");  // Monetary value in $US
//  lineChart.setXFormat("0000");      // Year
   
  // Symbol colours
  lineCharts.get(index).setPointColour(color(0));
  lineCharts.get(index).setLineColour(color(255,0,0));
  lineCharts.get(index).setPointSize(5);
  lineCharts.get(index).setLineWidth(2);
}

int bwidth=30;
int bheight=30;
int bxstart = width-190;
int bystart = 50;
int byoffset = 50;
int lxstart = width-150;

PonyPlotLogo pplogo;
static int instance = 0;

public void settings() {
  if (instance==0) {
    size(1000,500);
    instance++;
  } else {
    //fullScreen();
    size(500,500);
  }
}

PFont chartfont;

public void setup()
{
  frameRate(10);
  surface.setResizable(true);
/*  
  cp5 = new ControlP5(this);
  
  cp5.addScrollableList("dropdown")
     .setPosition(100, 100)
     .setSize(200, 100)
     .setBarHeight(20)
     .setItemHeight(20)
     .addItems(Serial.list())
     .setType(ScrollableList.LIST) // currently supported DROPDOWN and LIST
     ;
*/
  pplogo = new PonyPlotLogo(this);
  chartfont = createFont("Arial",10);
  setup_serial_connection();
  
  addChartWithSettingsAndData();
}



Boolean arduinoStartReceived = false;

public void checkArduino() {
  while(arduinoMessageAvailable()) {
    TimeStampedString tts = getArduinoMessage();
    String msg = tts.string;
//    println("From arduino: -->"+msg+"<--");
    if ("0123456789.-".contains(msg.substring(0,1)) ) {
//      println("data >"+msg+"<");
        String[] parts;
        if (msg.contains(" ")) {
          parts = msg.split(" ");
          if (parts.length==2) {
            try {
              PVector v = new PVector(Float.parseFloat(parts[0]),Float.parseFloat(parts[1]));
              if (v.y<=setMaxY && v.y>=setMinY) {
                graphData.get(activeChart).add(v);
                if (maxXDataLength>0) {
                  if (graphData.get(activeChart).size()>maxXDataLength) {
                    graphData.get(activeChart).remove(0);  
                }
              }
            }
          } catch(Exception e) {
            e.printStackTrace();
          }
          }
        } else 
        if (msg.contains("\t")) {
          parts = msg.split("\t");
        } else
        if (msg.contains(";")) {
          parts = msg.split(";");
        } else
        if (msg.contains(",")) {
          parts = msg.split(",");
        } else {
          if (graphData.get(0).size()==0) {
            graphStartMillis = tts.millis;
          }
          try {
            PVector v = new PVector((tts.millis-graphStartMillis)/1000f,Float.parseFloat(msg));
            graphData.get(activeChart).add(v);
            if (maxXDataLength>0) {
              if (graphData.get(activeChart).size()>maxXDataLength) {
                graphData.get(activeChart).remove(0);
              }
              PVector first = graphData.get(activeChart).get(0);
              PVector last = graphData.get(activeChart).get(graphData.get(activeChart).size()-1);
              lineCharts.get(activeChart).setMinX(first.x);
              lineCharts.get(activeChart).setMaxX(last.x);
            }
          } catch(Exception e) {
            e.printStackTrace();
          }
        }
 
    } else {
      println("it's config: "+msg);
      if (msg.startsWith("title:")) {
        pageTitle = msg.substring(6);
      } else
      if (msg.startsWith("subtitle:")) {
        pageSubtitle = msg.substring(9);
      } else
      if (msg.startsWith("setMaxY:")) {
        try {
          setMaxY = Float.parseFloat(msg.substring(8));
          for (int i=0;i<lineCharts.size();i++) {
            lineCharts.get(i).setMaxY(setMaxY);
          }  
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setMinY:")) {
        try {
          setMinY = Float.parseFloat(msg.substring(8));
          for (int i=0;i<lineCharts.size();i++) {
            lineCharts.get(i).setMinY(setMinY);
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setMaxX:")) {
        try {
          setMaxX = Float.parseFloat(msg.substring(8));
          for (int i=0;i<lineCharts.size();i++) {
            lineCharts.get(i).setMaxX(setMaxX);
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setMinX:")) {
        try {
          setMinX = Float.parseFloat(msg.substring(8));
          for (int i=0;i<lineCharts.size();i++) {
            lineCharts.get(i).setMinX(setMinX);
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setYFormat:")) {
        lineCharts.get(activeChart).setYFormat(msg.substring(11));
      } else
      if (msg.startsWith("setXFormat:")) {
        lineCharts.get(activeChart).setXFormat(msg.substring(11));
      } else
      if (msg.startsWith("setXAxisLabel:")) {
        lineCharts.get(activeChart).setXAxisLabel(msg.substring(14));
      } else
      if (msg.startsWith("setYAxisLabel:")) {
        lineCharts.get(activeChart).setYAxisLabel(msg.substring(14));
      } else
      if (msg.startsWith("setLineWidth:")) {
        lineCharts.get(activeChart).setLineWidth(Float.parseFloat(msg.substring(13)));
      } else
      if (msg.startsWith("setPointColor:")) {
        String[] rgb=msg.substring(14).split(",");
        lineCharts.get(activeChart).setPointColour(color(Integer.parseInt(rgb[0]),Integer.parseInt(rgb[1]),Integer.parseInt(rgb[2])));
      } else
      if (msg.startsWith("button:")) {
        String[] parts = msg.split(":");
        Button button = new Button();
        button.code = parts[1];
        button.text = parts[2];
        String[] rgb = parts[3].split(",");
        button.col=color(Integer.parseInt(rgb[0]),Integer.parseInt(rgb[1]),Integer.parseInt(rgb[2]));
        buttons.add(button);
      } else
      if (msg.startsWith("activeGraph:")) {
        try {
          activeChart=Integer.parseInt(msg.substring(12));
          while (lineCharts.size()<activeChart+1) {
            addChartWithSettingsAndData();
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setXDataLength:")) {
        try {
          maxXDataLength=Integer.parseInt(msg.substring(15));
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("start:")) {
        arduinoStartReceived=true;
        while (graphData.size()>0) {
          graphData.remove(0);
        }
        while (lineCharts.size()>0) {
          lineCharts.remove(0);
        }
        while (buttons.size()>0) {
          buttons.remove(0);
        }
        addChartWithSettingsAndData();
      }
    }
  }
}

// Draws the chart and a title.
public void draw()
{
  background(255);
  check_serial_health();
  checkArduino();
  
  textFont(chartfont,10);
  textSize(40);
  fill(0);
  stroke(0);
  if (arduinoStartReceived) {
    for (int i=0;i<lineCharts.size();i++) {
      if (i==0) {
        lineCharts.get(i).setData(graphData.get(i));
        lineCharts.get(i).updateLayout();
        lineCharts.get(i).draw(50,50,width-100,height-100);
      } else {
        lineCharts.get(i).updateLayout();
        lineCharts.get(i).setData(graphData.get(i));
        lineCharts.get(i).draw(50+lineCharts.get(0).getLeftSpacing(),
                              50+lineCharts.get(0).getTopSpacing(),
                              width-100-lineCharts.get(0).getRightSpacing()-lineCharts.get(0).getLeftSpacing(),
                              height-100-lineCharts.get(0).getBottomSpacing()-lineCharts.get(0).getTopSpacing());
      }
    }
    fill(0);
    stroke(0);
    textSize(40);
    textAlign(CENTER, CENTER);
    text(pageTitle, width/2,30);
    textSize(20);
    text(pageSubtitle, width/2,45);
    
    float alpha = millis()-lastMouseMoved;
    if (alpha<3000) {
      alpha = 255.0f;
    } else {
      alpha = max(0,(4000-alpha) / 4);
    }
    alpha = 255;
    lxstart = width-250;
    bxstart = width-290;
    for (int i=0;i<buttons.size();i++) {  
      
      // rechteck legende
      fill(color(red(buttons.get(i).col),green(buttons.get(i).col),blue(buttons.get(i).col),alpha));
      strokeWeight(0);
      rect(bxstart,bystart+i*byoffset,30,30);
      
      // button
      fill(190,alpha);
      strokeWeight(2);
      //rect(bxstart,20+i*50,bwidth,30);
      
      fill(color(0,0,0,alpha));
      textSize(40);
      if (alpha>0) {
        textAlign(LEFT, CENTER);
        text(buttons.get(i).text,lxstart,bystart+i*byoffset+bheight/2);
      }
    }
  } else {
    fill(0);
    textSize(50);
    textAlign(CENTER, CENTER);
    text("Waiting for Arduino", width/2,height*0.9f);
    pplogo.drawLogo(width/2-100,height/2-100,200,200);
  }
}

public void keyPressed() {
  
}

long lastMouseMoved;
public void mouseMoved() {
  lastMouseMoved = millis();
}


public void mouseClicked() {
  // docu: https://github.com/processing/processing/blob/master/core/src/processing/core/PApplet.java
  
  //PApplet.main(new String[] { "--sketch-path="+sketchPath(), this.getClass().getSimpleName() });
  //PApplet.runSketch(new String[] {  "--sketch-path="+sketchPath(),this.getClass().getSimpleName()}, new arduino_plotter_multi());
  //dispose();
  
  for (int i=0;i<buttons.size();i++) {   
      if (mouseX>bxstart && mouseX<bxstart+bwidth) {
        if (mouseY>bystart+i*byoffset && mouseY<bystart+i*byoffset+bheight) {
          arduinoPort.write(buttons.get(i).code);  
        }
      }
    }
}
/*

Damit der Sketch läuft:

Sketch -> Library importieren -> Library hinzufügen: giCentreUtils 3.4.0

// http://gicentre.org/utils/reference/
// https://www.gicentre.net/utils

*/

class PonyPlotLogo {
  
  private PApplet parent;
  float[] startpointsX = { 157.0f, 143.0f, 181.0f, 147.0f, 212.0f, 162.0f, 233.0f, 177.0f, 248.0f, 196.0f, 268.0f, 211.0f, 288.0f, 230.0f, 313.0f, 243.0f, 338.0f, 263.0f, 356.0f, 280.0f, 376.0f, 294.0f, 391.0f, 327.0f, 391.0f, 359.0f, 392.0f, 383.0f, 390.0f, 404.0f, 394.0f, 427.0f, 393.0f, 446.0f, 393.0f, 452.0f, 390.0f, 471.0f, 392.0f, 495.0f, 394.0f, 520.0f, 391.0f, 541.0f, 389.0f, 558.0f, 386.0f, 581.0f, 365.0f, 605.0f, 353.0f, 618.0f, 340.0f, 621.0f, 321.0f, 621.0f };
  float[] startpointsY = { 454.0f, 428.0f, 464.0f, 394.0f, 466.0f, 374.0f, 451.0f, 356.0f, 447.0f, 335.0f, 442.0f, 321.0f, 434.0f, 303.0f, 427.0f, 284.0f, 425.0f, 268.0f, 417.0f, 243.0f, 413.0f, 219.0f, 401.0f, 197.0f, 401.0f, 188.0f, 410.0f, 174.0f, 403.0f, 168.0f, 405.0f, 135.0f, 403.0f, 113.0f, 409.0f, 184.0f, 406.0f, 193.0f, 404.0f, 204.0f, 406.0f, 219.0f, 415.0f, 242.0f, 438.0f, 268.0f, 443.0f, 293.0f, 474.0f, 319.0f, 489.0f, 355.0f, 507.0f, 401.0f, 536.0f, 440.0f };

  int pointcounter = 0;
  long lastMillis = 0;
  ArrayList<PVector> points = new ArrayList<PVector>();
  PImage pplogo_background;
  PFont font;
  
  PonyPlotLogo(PApplet _parent) {
    parent = _parent;
    pplogo_background = loadImage("ponyplot_logo_background.jpeg");
    // from https://www.fontsupply.com/fonts/C/Courier.html
    font = createFont("COURIER.TTF",150);
//    println("startpoints.length: "+startpointsX.length);
    
    for (int i=0;i<startpointsX.length;i++) {
      points.add(new PVector( startpointsX[i],startpointsY[i])); 
    }
  }
  public void drawLogo(int x, int y, int w, int h) {
    drawLogo((float)x,(float)y,(float)w,(float)h);
  }
  public void drawLogo(float x, float y, float w, float h) {
    int drawPointsTill = points.size()-2;
    if (pointcounter<points.size()-1) {
       drawPointsTill = pointcounter;
    }
    if (millis()>lastMillis) {
      image(pplogo_background,x,y,w*800/800,h*800/800);
      strokeWeight(13f/800f*w);
      stroke(171,255,221,150);
      for (int i=0;i<drawPointsTill;i++) {
        line(points.get(i).x/800*w+x,points.get(i).y/800*h+y,points.get(i+1).x/800*w+x,points.get(i+1).y/800*h+y);  
      }
      lastMillis = millis();
    }
    fill(0,0,0,lerp(0,255,max(1.0f,(float)pointcounter / 56.0f)));
    textAlign(CENTER, CENTER);
    textFont(font);
    textSize((int)(150f/800*w));
    text("PonyPlot",w/2+x,630f/800*h+y);
    pointcounter++;
    if (pointcounter>70) {
      pointcounter = 0;  
    }
  }
}


Serial arduinoPort;  // Create object from Serial class
String arduinoPortName; // name of the port
int arduinoPortListLength;

public void setup_serial_connection() {
  printArray(Serial.list());
  arduinoPortListLength = Serial.list().length;
  if (arduinoPortListLength>0) {
    arduinoPortName = Serial.list()[Serial.list().length-1];
    println("opening port: "+arduinoPortName);
    arduinoPort = new Serial(this, arduinoPortName, 9600);
  }
}

public void check_serial_health() {
  int l = Serial.list().length;
  if (l<arduinoPortListLength) {
    arduinoPortListLength=l;
    arduinoPort.stop();
    print("disconnected!");
  }
  if (l>arduinoPortListLength) {
    print("reconnected!");
    delay(200);
    setup_serial_connection();
  }
}
class TimeStampedString {
  String string;
  int millis;
  TimeStampedString(String s) {
    string = s;
    millis = millis();
  }
}
ArrayList<TimeStampedString> arduinoStack = new ArrayList<TimeStampedString>();
Object arduinoStackLock = new Object();

public Boolean arduinoMessageAvailable() {
  synchronized(arduinoStackLock) {
    return arduinoStack.size()>0;
  }
}
public TimeStampedString getArduinoMessage() {
  synchronized(arduinoStackLock) {
    if (arduinoStack.size()==0) return null;
    return arduinoStack.remove(0);
  }
}

String arduinoMsg="";

public void serialEvent(Serial myPort) {
  while( myPort.available() > 0) {  // If data is available,
    int val = myPort.read();    // read it and store it in val
    if ( (val==13) || (val==10) ) { // end of line?
      if (arduinoMsg.length()>0) {
        synchronized(arduinoStackLock) {
          TimeStampedString tss = new TimeStampedString(arduinoMsg);
          arduinoStack.add(tss);
          arduinoMsg="";
        }
      }
    } else {
      byte[] asciibytes = { (byte)val };
      try {
      arduinoMsg = arduinoMsg + new String(asciibytes, "ASCII");; //char(val); // add character to buffer
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "ponyplot" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
